-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["DEMONHUNTER"] = {}
local t,s,n
lib.classpreload["DEMONHUNTER"] = function()
end
lib.classes["DEMONHUNTER"][1] = function()
	lib.SetPower("FURY")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
	lib.LoadSwingTimer()
	cfg.talents={
		["Fel Mastery"]=IsPlayerSpell(192939),
		["Prepared"]=IsPlayerSpell(203551),
		["Demon Blades"]=IsPlayerSpell(203555),
		["First Blood"]=IsPlayerSpell(206416),
		["Momentum"]=IsPlayerSpell(206476),
		["Bloodlet"]=IsPlayerSpell(206473),
		--["RJW"]=IsPlayerSpell(116847) --Rushing Jade Wind
	}
	cfg.dh_cap=50
	if cfg.talents["First Blood"] then
		cfg.dh_cap=55
	end
	lib.AddSpell("Chaos Strike",{201427,162794})
	lib.AddSpell("Blade Dance",{210152,188499},true)
	lib.AddSpell("Metamorphosis",{191427})
	lib.AddSpell("Vengeful Retreat",{198793})
	lib.AddSpell("Fel Eruption",{211881},"target")
	lib.AddSpell("Fury of the Illidari",{201467})
	lib.AddAura("Metamorphosis",162264,"buff","player")
	lib.AddAura("Momentum",208628,"buff","player")
	if not cfg.talents["Demon Blades"] then
		lib.AddSpell("Demon's Bite",{162243})
	end
	lib.AddSpell("Fel Rush",{195072})
	lib.AddSpell("Throw Glaive",{185123})
	lib.AddSpell("Eye Beam",{198013},nil,nil,true)
	lib.SetAuraFunction("Metamorphosis","OnApply",function()
		lib.ReloadSpell("Chaos Strike",{201427,162794})
		lib.ReloadSpell("Blade Dance",{210152,188499},true)
		end)
	lib.SetAuraFunction("Metamorphosis","OnFade",function()
		lib.ReloadSpell("Chaos Strike",{162794,201427})
		lib.ReloadSpell("Blade Dance",{188499,210152},true)
	end)
	
	lib.AddSpell("Felblade",{213241})
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	if cfg.talents["Prepared"] then
		table.insert(cfg.plistdps,"Vengeful Retreat_Prepared")
	end
	if cfg.talents["Fel Mastery"] then
		table.insert(cfg.plistdps,"Fel Rush_Fel Mastery")
		table.insert(cfg.plistdps,"Vengeful Retreat_ranged")
	else
		table.insert(cfg.plistdps,"Fel Rush_ranged")
	end
	table.insert(cfg.plistdps,"Throw Glaive_range")
	table.insert(cfg.plistdps,"Fury of the Illidari_Momentum")
	table.insert(cfg.plistdps,"Fury of the Illidari_Momentum")
	table.insert(cfg.plistdps,"Metamorphosis")
	
	table.insert(cfg.plistdps,"Eye Beam_aoe")
	table.insert(cfg.plistdps,"Eye Beam_single")
	table.insert(cfg.plistdps,"Blade Dance_aoe")
	
	if cfg.talents["First Blood"] then
		table.insert(cfg.plistdps,"Blade Dance")
	end
	
	table.insert(cfg.plistdps,"Felblade")
	table.insert(cfg.plistdps,"Chaos Strike")
	table.insert(cfg.plistdps,"Fury of the Illidari")
	if cfg.talents["Fel Mastery"] then
		table.insert(cfg.plistdps,"Fel Rush")
	end
	if cfg.talents["Demon Blades"] then
		table.insert(cfg.plistdps,"Throw Glaive")
	else
		table.insert(cfg.plistdps,"Demon's Bite")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Fury of the Illidari_Momentum"] = function()
			if lib.GetAura({"Momentum"})>lib.GetSpellCD("Fury of the Illidari") then
				return lib.SimpleCDCheck("Fury of the Illidari")
			end
			return nil
		end,
		["Felblade"] = function()
			if cfg.Power.now<cfg.Power.max-30 then
				return lib.SimpleCDCheck("Felblade",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return nil
		end,
		["Fel Rush_Fel Mastery"] = function()
			if not lib.inrange("Chaos Strike") then
				return lib.SimpleCDCheck("Fel Rush",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return lib.SimpleCDCheck("Fel Rush",lib.GetSpellCD("Fel Rush",nil,lib.GetSpellMaxCharges("Fel Rush"))-cfg.gcd)
		end,
		["Fel Rush_Prepared_ranged"] = function()
			if not lib.inrange("Chaos Strike") and (lib.IsLastSpell("Vengeful Retreat") or lib.IsLastSpell("Throw Glaive")) then
				return lib.SimpleCDCheck("Fel Rush",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return nil
		end,
		["Fel Rush_ranged"] = function()
			if not lib.inrange("Chaos Strike") then
				return lib.SimpleCDCheck("Fel Rush",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return nil
		end,
		["Vengeful Retreat_Prepared"] = function()
			if cfg.Power.now<=75 and lib.inrange("Chaos Strike") and (lib.GetSpellCD("Vengeful Retreat")+lib.GetSpellCD("gcd")==lib.GetSpellCD("Fel Rush") or lib.GetSpellCD("Vengeful Retreat")+lib.GetSpellCD("gcd")==lib.GetSpellCD("Throw Glaive")) then
				return lib.SimpleCDCheck("Vengeful Retreat",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return nil
		end,
		["Vengeful Retreat_ranged"] = function()
			if not lib.inrange("Chaos Strike") and lib.IsLastSpell("Fel Rush") then 
				return lib.SimpleCDCheck("Vengeful Retreat",lib.GetAura({"Momentum"})-cfg.gcd)
			end
			return nil
		end,
		["Eye Beam_aoe"] = function()
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Eye Beam",lib.GetAura({"Metamorphosis"}))
			end
			return nil
		end,
		["Eye Beam_single"] = function()
			if cfg.noaoe then
				return lib.SimpleCDCheck("Eye Beam",lib.GetAura({"Metamorphosis"}))
			end
			return nil
		end,
		["Chaos Strike"] = function()
			if cfg.Power.now<cfg.dh_cap then return nil end
			return lib.SimpleCDCheck("Chaos Strike")
			--[[if cfg.cleave_targets>=2 or cfg.noaue then
				if lib.GetSpellCD("Chaos Strike")<lib.GetSpellCD("Eye Beam") then
					return lib.SimpleCDCheck("Chaos Strike")
				else
					if cfg.Power.now>=50 then
						return lib.SimpleCDCheck("Chaos Strike")
					end
				end
			else
				return lib.SimpleCDCheck("Chaos Strike")
			end
			return nil]]
		end,
		["Blade Dance_aoe"] = function()
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Blade Dance")
			end
			return nil
		end,
		["Metamorphosis"] = function()
			if cfg.Power.now>=80 then
				return lib.SimpleCDCheck("Metamorphosis")
			end
			return nil
		end,
		["Throw Glaive_range"] = function()
			if not lib.inrange("Chaos Strike") then
				return lib.SimpleCDCheck("Throw Glaive")
			end
			return nil
		end,
	}
	
	lib.AddRangeCheck({
	{"Chaos Strike",nil},
	{"Kick",{0,0,1,1}},
	{"Throw Glaive",{0,1,0,1}},
	})
	return true
end
lib.classes["DEMONHUNTER"][2] = function()
	cfg.MonitorSpells=true
	lib.SetPower("PAIN")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
	cfg.talents={
		["Flame Crash"]=IsPlayerSpell(227322),
		--["Prepared"]=IsPlayerSpell(203551),
		--["Demon Blades"]=IsPlayerSpell(203555),
		--["First Blood"]=IsPlayerSpell(206416),
	}

	lib.AddSpell("Shear",{203782})
	lib.AddSpell("Demon Spikes",{203720})
	lib.AddAura("Demon Spikes",203819,"buff","player")
	lib.AddAura("Soul Fragments",203981,"buff","player")
	lib.SetTrackAura("Soul Fragments")
	--[[lib.SetAuraFunction("Soul Fragments","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Soul Fragments")>0 and lib.GetAuraStacks("Soul Fragments") or nil)
	end)]]
	lib.AddSpell("Soul Cleave",{228477})
	lib.AddSpell("Throw Glaive",{204157})
	lib.AddSpell("Immolation Aura",{178740},true)
	lib.AddSpell("Soul Carver",{207407},"target")
	lib.AddSpell("Infernal Strike",{189110})
	lib.SaveSpell(189111) --For Casts
	lib.AddSpell("Fel Eruption",{211881},"target")
	lib.AddSpell("Fiery Brand",{204021})
	lib.AddSpell("Felblade",{213241})
	lib.AddAura("Fiery Brand",207744,"debuff","target")
	
	
	lib.AddSpell("Sigil of Flame",{204596})
	lib.AddAura("Sigil of Flame",204598,"debuff","target")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	--table.insert(cfg.plistdps,"Throw Glaive_range")
	table.insert(cfg.plistdps,"Fiery Brand")
	table.insert(cfg.plistdps,"Demon Spikes")
	table.insert(cfg.plistdps,"Soul Carver")
	table.insert(cfg.plistdps,"Fel Eruption_noaoe")
	
	if cfg.talents["Flame Crash"] then
		table.insert(cfg.plistdps,"Infernal Strike_Flame Crash_aoe")
	end
	table.insert(cfg.plistdps,"Immolation Aura")
	if cfg.talents["Flame Crash"] then
		table.insert(cfg.plistdps,"Sigil of Flame_Flame Crash_aoe")
	else
		table.insert(cfg.plistdps,"Sigil of Flame_aoe")
	end
	if not cfg.talents["Flame Crash"] then
		table.insert(cfg.plistdps,"Infernal Strike_aoe")
	end
	
	table.insert(cfg.plistdps,"Soul Cleave_aoe")
	table.insert(cfg.plistdps,"Infernal Strike2")
	table.insert(cfg.plistdps,"Soul Cleave_cap")
	table.insert(cfg.plistdps,"Soul Cleave_heal")
	table.insert(cfg.plistdps,"Felblade")
	table.insert(cfg.plistdps,"Fel Eruption")
	table.insert(cfg.plistdps,"Sigil of Flame")
	table.insert(cfg.plistdps,"Shear")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Infernal Strike_aoe"] = function()
			if lib.IsLastSpell(189111) then return nil end
			if cfg.cleave_targets>1 then
				return lib.SimpleCDCheck("Infernal Strike")
			end
			return nil
		end,
		["Fel Eruption_noaoe"] = function()
			if cfg.cleave_targets<=1 or cfg.noaoe then
				return lib.SimpleCDCheck("Fel Eruption")
			end
			return nil
		end,
		["Demon Spikes"] = function()
			if lib.GetUnitHealth("player","percent")<=90 then
				return lib.SimpleCDCheck("Demon Spikes",lib.GetSpellCD("Demon Spikes",nil,lib.GetSpellMaxCharges("Demon Spikes"))-cfg.gcd)
			end
			return nil
		end,
		["Infernal Strike2"] = function()
			return lib.SimpleCDCheck("Infernal Strike",lib.GetSpellCD("Infernal Strike",nil,lib.GetSpellMaxCharges("Infernal Strike"))-cfg.gcd)
		end,
--[[		["Fiery Brand"] = function()
			if lib.GetUnitHealth("player","percent")<=90 then
				return lib.SimpleCDCheck("Fiery Brand")
			end
			return nil
		end,]]
		["Infernal Strike_Flame Crash_aoe"] = function()
			if lib.IsLastSpell(189111) then return nil end
			if lib.IsLastSpell("Sigil of Flame") then return nil end
			if cfg.cleave_targets>1 then
				return lib.SimpleCDCheck("Infernal Strike",lib.GetAura({"Sigil of Flame"})-3.8)
			end
			return nil
		end,
		["Sigil of Flame_Flame Crash_aoe"] = function()
			if lib.IsLastSpell(189111) then return nil end
			if cfg.cleave_targets>1 then
				return lib.SimpleCDCheck("Sigil of Flame",lib.GetAura({"Sigil of Flame"})-3.8)
			end
			return nil
		end,
		["Sigil of Flame_aoe"] = function()
			if cfg.cleave_targets>1 then
				return lib.SimpleCDCheck("Sigil of Flame",lib.GetAura({"Sigil of Flame"})-3.8)
			end
			return nil
		end,
		["Soul Cleave_cap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,
		["Soul Cleave_aoe"] = function()
			if cfg.cleave_targets>1 then
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,
		["Soul Cleave_heal"] = function()
			if lib.GetUnitHealth("player","percent")<=80 then
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,
		["Felblade"] = function()
			if cfg.Power.now<cfg.Power.max-20 then
				return lib.SimpleCDCheck("Felblade")
			end
			return nil
		end,
		["Immolation Aura"] = function()
			if cfg.Power.now<=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Immolation Aura")
			end
			return nil
		end,
		["Throw Glaive_range"] = function()
			if not lib.inrange("Soul Cleave") then
				return lib.SimpleCDCheck("Throw Glaive")
			end
			return nil
		end,
	}
	
	--[[lib.AddRangeCheck({
	{"Soul Cleave",nil},
	{"Kick",{0,0,1,1}},
	{"Throw Glaive",{0,1,0,1}},
	})]]
	return true
end

lib.classpostload["DEMONHUNTER"] = function()
	lib.SetInterrupt("Kick",{183752})
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Throw Glaive")
		lib.CDadd("Fury of the Illidari")
		lib.CDadd("Fiery Brand")
		lib.CDadd("Demon Spikes")
		lib.CDadd("Metamorphosis")
		lib.CDadd("Vengeful Retreat")
		lib.CDAddCleave("Eye Beam",nil,198030)
		lib.CDAddCleave("Blade Dance",nil,200685)
		lib.CDAddCleave("Fel Rush",nil,192611)
		lib.CDAddCleave("Soul Cleave",nil,228478)
		lib.CDAddCleave("Immolation Aura",nil,178741) -- 187727
		lib.CDAddCleave("Infernal Strike",nil,189112,189111)
		--lib.CDAddCleave("Sigil of Flame")
	end
end
end